AuthenticatedData (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.asn1.cms

## Class AuthenticatedData

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.cms.AuthenticatedData

- All Implemented Interfaces:
    ASN1Encodable, Encodable

      public class AuthenticatedData
      extends ASN1Object

  RFC 5652 section 9.1: The AuthenticatedData carries AuthAttributes and other data which define what really is being signed.

       AuthenticatedData ::= SEQUENCE {
             version CMSVersion,
             originatorInfo [0] IMPLICIT OriginatorInfo OPTIONAL,
             recipientInfos RecipientInfos,
             macAlgorithm MessageAuthenticationCodeAlgorithm,
             digestAlgorithm [1] DigestAlgorithmIdentifier OPTIONAL,
             encapContentInfo EncapsulatedContentInfo,
             authAttrs [2] IMPLICIT AuthAttributes OPTIONAL,
             mac MessageAuthenticationCode,
             unauthAttrs [3] IMPLICIT UnauthAttributes OPTIONAL }

       AuthAttributes ::= SET SIZE (1..MAX) OF Attribute

       UnauthAttributes ::= SET SIZE (1..MAX) OF Attribute

       MessageAuthenticationCode ::= OCTET STRING

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AuthenticatedData(OriginatorInfo originatorInfo, ASN1Set recipientInfos, AlgorithmIdentifier macAlgorithm, AlgorithmIdentifier digestAlgorithm, ContentInfo encapsulatedContent, ASN1Set authAttrs, ASN1OctetString mac, ASN1Set unauthAttrs)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static int` | `calculateVersion(OriginatorInfo origInfo)`
    `ASN1Set` | `getAuthAttrs()`
    `AlgorithmIdentifier` | `getDigestAlgorithm()`
    `ContentInfo` | `getEncapsulatedContentInfo()`
    `static AuthenticatedData` | `getInstance(ASN1TaggedObject obj, boolean explicit)` Return an AuthenticatedData object from a tagged object.
    `static AuthenticatedData` | `getInstance(java.lang.Object obj)` Return an AuthenticatedData object from the given object.
    `ASN1OctetString` | `getMac()`
    `AlgorithmIdentifier` | `getMacAlgorithm()`
    `OriginatorInfo` | `getOriginatorInfo()`
    `ASN1Set` | `getRecipientInfos()`
    `ASN1Set` | `getUnauthAttrs()`
    `ASN1Integer` | `getVersion()`
    `ASN1Primitive` | `toASN1Primitive()` Produce an object suitable for an ASN1OutputStream.

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `encodeTo, encodeTo, equals, getEncoded, getEncoded, hasEncodedTagValue, hashCode`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AuthenticatedData

          public AuthenticatedData(OriginatorInfo originatorInfo,
                                   ASN1Set recipientInfos,
                                   AlgorithmIdentifier macAlgorithm,
                                   AlgorithmIdentifier digestAlgorithm,
                                   ContentInfo encapsulatedContent,
                                   ASN1Set authAttrs,
                                   ASN1OctetString mac,
                                   ASN1Set unauthAttrs)

  - ### Method Detail

    - #### getInstance

          public static AuthenticatedData getInstance(ASN1TaggedObject obj,
                                                      boolean explicit)

      Return an AuthenticatedData object from a tagged object.
      Parameters:
        `obj` - the tagged object holding the object we want.
        `explicit` - true if the object is meant to be explicitly tagged false otherwise.
      Returns:
        a reference that can be assigned to AuthenticatedData (may be null)
      Throws:
        `java.lang.IllegalArgumentException` - if the object held by the tagged object cannot be converted.

    - #### getInstance

          public static AuthenticatedData getInstance(java.lang.Object obj)

      Return an AuthenticatedData object from the given object.

      Accepted inputs:

      - null → null
      - `AuthenticatedData` object
      - `ASN1Sequence` input formats with AuthenticatedData structure inside
      Parameters:
        `obj` - the object we want converted.
      Returns:
        a reference that can be assigned to AuthenticatedData (may be null)
      Throws:
        `java.lang.IllegalArgumentException` - if the object cannot be converted.

    - #### getVersion

          public ASN1Integer getVersion()

    - #### getOriginatorInfo

          public OriginatorInfo getOriginatorInfo()

    - #### getRecipientInfos

          public ASN1Set getRecipientInfos()

    - #### getMacAlgorithm

          public AlgorithmIdentifier getMacAlgorithm()

    - #### getDigestAlgorithm

          public AlgorithmIdentifier getDigestAlgorithm()

    - #### getEncapsulatedContentInfo

          public ContentInfo getEncapsulatedContentInfo()

    - #### getAuthAttrs

          public ASN1Set getAuthAttrs()

    - #### getMac

          public ASN1OctetString getMac()

    - #### getUnauthAttrs

          public ASN1Set getUnauthAttrs()

    - #### toASN1Primitive

          public ASN1Primitive toASN1Primitive()

      Produce an object suitable for an ASN1OutputStream.
      Specified by:
        `toASN1Primitive` in interface `ASN1Encodable`
      Specified by:
        `toASN1Primitive` in class `ASN1Object`
      Returns:
        a primitive representation of this object.

    - #### calculateVersion

          public static int calculateVersion(OriginatorInfo origInfo)